import sys
from string import join

class base_plugin:
	def __init__(self, ph):
		self.ph = ph
		self.name = 'base_plugin'

		ph.register_command(self, 'help', self.help, 'help')
		ph.register_command(self, 'quit', self.quit, 'quit application', {'op_only':1})

	def help(self, args):
		shorthelp = []
		allcmds = self.ph.commands().keys()
		allcmds.sort()
		for cmdname in allcmds:
			cmd = self.ph.commands()[cmdname]
			shorthelp.append("/%-10s  %s" % (cmd['name'], cmd['help']))
		self.ph.send_back(args['con'], args['msg'], '\n'+join(shorthelp, '\n'))
		
	def quit(self, args):
		args['con'].disconnect()
		sys.exit(0)


## test
if __name__ == '__main__':
	class p:
		def __init__(self):
		        self.__plugins = []
			self.__commands = {}
						
		def register_command(self, module, name, function, help=''):
			pass
		def send_back(self, con, msg, message):
			pass
	
	ph = p()
	
	bp = base_plugin(ph)
