import sys
from string import join
import SOAPpy

class google_plugin:
	def __init__(self, ph):
		self.ph = ph
		self.name = 'google_plugin'
		self.__key = ph.get_config('google_key')

		ph.register_command(self, 'google', self.google, '[param] search google')

	def __search(self, searchstring, maxresults = 5):
		google_key = self.__key
		soapfalse = SOAPpy.booleanType(0)
		server = SOAPpy.SOAPProxy('http://api.google.com/search/beta2', namespace='urn:GoogleSearch')
		data = server.doGoogleSearch( google_key, searchstring, 0, maxresults, soapfalse, '', soapfalse, '', '', '')
		return [node._asdict() for node in data.resultElements]
		
	def google(self, args):
		search = join(args['cmd'][1:], ' ')
		result = self.__search(search)
		outputs = [r['title']+'\n'+r['URL'] for r in result]
		output = join(outputs, '\n\n')
		if output == '':
			output = 'not result'
		self.ph.send_back(args['con'], args['msg'], '\n'+output)
		
## test
if __name__ == '__main__':
	class p:
		def __init__(self):
		        self.__plugins = []
			self.__commands = {}
						
		def register_command(self, module, name, function, help='', args={}):
			pass
		def send_back(self, con, msg, message):
			pass
	
	ph = p()
	
	bp = google_plugin(ph)
